/*
 * osdlist.h
 *
 * Copyright (C) 2008 Christophe Thommeret <hftom@free.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef OSDLIST_H
#define OSDLIST_H

#include "osdlistitem.h"
#include "osdvscrollbar.h"
#include "osdobject.h"



class OsdList : public OsdObject
{
	Q_OBJECT
public:
	OsdList( OsdConfig *conf );
	~OsdList();
	void resize( int w, int h );
	void appendEntry( OsdListItem *it );
	void clear();

	void mouseMove( QPoint &p );
	bool mouseClicked( QMouseEvent *e );
	void mouseReleased( QMouseEvent *e );
	void wheelEvent( QWheelEvent *e );
	void paint();

private slots:
	void barScrolled( int off );

private:
	QList<OsdListItem *> itemList;
	OsdVScrollBar *bar;
	int scroll;
};

#endif // OSDLIST_H
